// --- [ main.c ] ------------------------------------------------------------

#define EXTERN
#include <windows.h>
#include <stdio.h>
#include <ctype.h>
#include <stdlib.h>
#include "ftd2xx.h"
#include <dos.h>
#include <time.h>
#include "ftdi.h"
#include "xbee_api.h"

// --- globale Variablen ---
#include "global.h"

extern char target_adr[DEVICES][8];
extern char target_network_adr[DEVICES][2];

unsigned int hexstring_to_hex(unsigned char * txt);
unsigned char hex_to_dez(unsigned char);
unsigned char read_xbee_adresses(void);

// ----------------------------------------------------------------------------
// ffnet die serielle Schnittstelle, liest die Target-Adressen aus einer Datei ein
// und arbeitet dann in einer Endlosschleife
int main(int argc, char* argv[])
{
LONG COMPORT = 0;
char COMx[5];
unsigned int i;
unsigned char frame_id = 0;               // fortlaufende ID der Messages
unsigned char last_frame_id;              // die zuletzt versandte msg_id

rm_device = 0;                            // Koordinator !!

ftStatus = FT_Open(0, &ftHandle);

if(ftStatus != FT_OK)
	{
	printf("opening failed! error: %d\n", ftStatus);
	getchar();
	return 1;
	}

ftStatus = FT_GetComPortNumber(ftHandle,&COMPORT);

if(ftStatus != FT_OK)
	{
   printf("ftHandle: %i\n", ftHandle);
	printf("comport : %i\n", COMPORT);
	printf("ftStatus: %i\n", ftStatus);
	getchar();
	return 1;
	}

if (COMPORT == -1)
	{
	printf("no com port installed \n");
	getchar();
	}

else
	{
	printf("COM Port   : %d\n", COMPORT);
	}

GetDevice_Info();
SetDevice_Baudrate();
if (!(read_xbee_adresses() == TRUE)) return(1);

while(1)                               // Hauptschleife
	{
	if (get_data() == 0) break;
	}

FT_Close(ftHandle);

return 0;
}

// ----------------------------------------------------------------------------
// liest eine Eingabe nach msg[]
unsigned int get_data(void)
{
unsigned int l,i,j;
char lf[2] = {10,0};
unsigned char txt[30];                    // Hier steht die Eingabe aus der Kommandozeile,
                      							// aber umgewandelt in Grossschreibung
j = TRUE;
while (j == TRUE)                      	// Schleife, um ggf. nur neu empfangene Daten anzuzeigen
	{
	printf("\n[ ");
	for (i = 0; i < 8; i++) printf("%X ", (unsigned char) target_adr[rm_device][i]);
	printf("] Target #%d -> ", rm_device);
	scanf("%s", msg);                      // Eingabe nach msg[] einlesen

	l =  strlen(msg);                      // die Lnge der Eingabe
	if ((l == 1) && (msg[0] == '#')) return(0); // das Programm mit '#' beenden

	if ((l == 1) && (msg[0] == '+'))       // mit '+' nur nach eingegangenen Daten suchen
		{
		printf("looking for received data ... ");
		rs232_read(FALSE);                  //
		}
	else if ((l == 1) && (msg[0] == '-')) system("CLS"); // den Bildschirm lschen
	else j = FALSE;                        // alle anderen Flle beenden das while()
	}

system("CLS");                         	// Screen lschen
flush_rx_buffer();                     	// Testen ob Daten im Puffer sind
														// ggf. ausgeben und lschen

														// wenn '#x' eingegeben wurde
if ((l == 2) && (msg[0] == '#') && (isdigit(msg[1]))) // anderes Target einstellen
	{
	l = msg[1] - '0';

	if (l < DEVICES) rm_device = l; else printf("\nInvalid Device\n");
	printf("\nNew Target : %d", rm_device);
	printf("\nDestination: ");
	for (l = 0; l < 8; l++) printf("%X ", (unsigned char) target_adr[rm_device][l]);
	printf("\nNetworkadr : ");
	for (l = 0; l < 2; l++) printf("%X ", (unsigned char) target_network_adr[rm_device][l]);
	printf("\n");
	return(1);
	}

for(i = 0; i <= l; i++)                	// alle Buchstaben in Grobuchstaben umwandeln
	{                                   	// incl. Terminator nach txt[] kopieren
	if (islower(msg[i])) txt[i] = toupper(msg[i]);
	else txt[i] = msg[i];
	}

														// Testen auf ATxx
if ((txt[0] == '+') && (txt[1] == '+') && (l > 3) && ((isupper(txt[2])) || (txt[2] == '%')))
	{
	printf("AT-Command: AT%s\n\n", &txt[2]);// das AT-Command ohne ++ ausgeben
	l = hexstring_to_hex(txt);
	API_at_cmd(txt, l);							// die Lnge des AT-Befehls-Strings bergeben
	}

else if ((txt[0] == '#') && (txt[1] == '#') && (l > 3) && ((isupper(txt[2])) || (txt[2] == '%')))
	{
	printf("Remote AT-Command: AT%s\n\n", &txt[2]); // das AT-Command ohne ## ausgeben
	l = hexstring_to_hex(txt);
	API_remote_at_cmd_request(rm_device, txt, l);  // Adresse und Command
	}

else
	{
	printf("ZigBee Transmit Request: %s\n\n", msg);  // Diese Daten wurden nicht in Groschreibung umgewandelt !!
	API_Tx_Request(rm_device, msg);
	rs232_read(TRUE);
	}

return(i);
}

// ----------------------------------------------------------------------------
// wandelt den optionalen Parameter eines AT-Kommandos
// als hexadezimalen Zahlenstring in eine Bytefolge um
// (jeweils zwei Ziffern werden zusammengefasst zu 1 Byte)
unsigned int hexstring_to_hex(unsigned char * txt)
{
unsigned int i, j, x, y, l;
i = strlen(txt);                          // die Lnge der Zeichenfolge
if (i == 4) return(i);                    // beenden, wenn kein Parameter vorhanden

if ((txt[2] == 'N') && (txt[3] == 'I'))	// wenn ATNI eingegeben wurde, dann folgt ein String !
	{
	return(i);                             // der String ist bereits in Grossschreibung umgewandelt !!
	}

x = TRUE;
for (j = 4; j < i; j++)                   // alle Zeichen prfen, ob es Ziffern sind
	{
	if (!(isxdigit(txt[j]))) x = FALSE;
	}
if (x == FALSE) return (i);          		// es sind nicht nur Ziffern enthalten

// als Parameter sind i - 4 Ziffern erkannt
// jeweils 2 Ziffern werden zu einem Byte zusammengefasst
// bei einer ungeraden Anzahl besteht das hchstwertigste Byte nur aus 1 Ziffer

x = y = 4;                                // Index fr Bytes und Ziffern
if ((i - 4 ) % 2 == 1)                    // ungerade Anzahl
	{
	txt[x++] = hex_to_dez(txt[y++]);       // nur 1 Ziffer
	}

while (y < i)                             // Jetzt sind immer Ziffernpaare zu bearbeiten
	{
	txt[x]    = (hex_to_dez(txt[y++]) * 16);
	txt[x++] +=  hex_to_dez(txt[y++]);
	}
return(x);
}

// ----------------------------------------------------------------------------
unsigned char hex_to_dez(unsigned char h)
{
unsigned char d;
if (h <= '9') d = h - '0'; else d = h - 'A' + 10;
return(d);
}

// ----------------------------------------------------------------------------
// Liest die 8 Byte Seriennummern sowie die Netzwerkadressen der Radios aus
// der Datei 'xbee_adr.cfg' ein.
// vorbelegt sind bereits fr :
// Device#0 = Coordinator (default)
// Device#1 = Broadcast
unsigned char read_xbee_adresses(void)
{
FILE *file;
unsigned char i, j, x, z;
unsigned int c;

if ((file = fopen("xbee_adr.cfg", "r")) == NULL)
	{
	printf("can't open 'xbee_adr.cfg'\n");
	getchar();                             // auf Eingabe warten
	}

else                                      // Daten ab einlesen
	{
	z = 2;
	i = j = 0;
	while(((c = getc(file)) != EOF) && (z < DEVICES))
		{
		if (c < 30) continue;                  // CR und LF ignorieren
		if (!(isxdigit(c)))
			{
			printf("\nInvalid character in 'xbee_adr.cfg'\n");
			getchar();
			getchar();
			return(FALSE);
			}
		if ((i % 2) == 0) x = hex_to_dez(c) * 16; // Gerade Stelle
		else                                   // ungerade Stelle
			{
			x += hex_to_dez(c);
			if (j < 8) target_adr[z][j] = x;
			else target_network_adr[z][j-8] = x;
			j++;
			if (j > 9)
				{
				j = 0;
				z++;
				}
			}
		i++;
		}
	fclose(file);
	}


for (z = 0; z < DEVICES; z++)             // gibt die gesamten Daten aus
	{
	printf("\nTarget #%X: ", z);
	for (j = 0; j < 10; j++)
		{
		if (j == 0) printf("Device Adr: ");
		if (j == 8) printf("Network Adr: ");
		if (j < 8) printf("%X ", (unsigned char) target_adr[z][j]);
		else printf("%X ", (unsigned char) target_network_adr[z][j-8]);
		}
	}
printf("\n\n");
return(TRUE);
}


// --- [ end of file ] --------------------------------------------------------
